program grafbmp_test;

{ (c) Heiko Purnhagen   23-jul-96 971207 }

uses
  graph,dos,crt,
  grafbmp;

type
  pbat = array [0..38399] of byte;

var
  graphdriver : integer;
  graphmode : integer;

  fnr,fnw : string;
  mode : integer;
  w,h,c : integer;
  inv : boolean;
  xoff,yoff,x0,y0,xs,ys,zoom,thr,rot : integer;
  s,s2,ss : string;
  xx,yy : integer;
  r : registers;
  c00 : boolean;
  fgc,bgc : integer;
  i : integer;
  cc : char;

  bmpbuf1 : bmpbufp;
  pba : ^pbat;
  ww,wr : word;

  timer : word absolute $0040:$006c;
  { 1193180 Hz / 65536 = 18.206482 Hz }
  tm : array[0..3] of array[0..2] of word;

  f : file;
  fb : file of byte;
  b : byte;
  b1024 : array[1..1024] of byte;

begin
  if paramcount = 0 then
  begin
    writeln ('usage: grafbmpt 0 fnr');
    writeln ('usage: grafbmpt 1 fnr x0 y0 inv');
    writeln ('usage: grafbmpt 2 fnr x0 y0 inv fnw xs ys thr');
    writeln ('usage: grafbmpt 3 fnr xoff yoff x0 y0 xs ys zoom rot thr bgc fgc');
    writeln ('neg mode -> cga 640*200');
    exit;
  end
  else
  begin
    val(paramstr(1),mode,i);
    graphdriver := detect;
    if mode < 0 then
    begin
      mode := -mode;
      graphdriver := cga;
      graphmode := cgahi;
    end;
    fnr := paramstr(2);
    if (mode = 1) or (mode = 2) then
    begin
      if i = 0 then
        val(paramstr(3),x0,i);
      if i = 0 then
        val(paramstr(4),y0,i);
      inv := (copy(paramstr(5),1,1) = 't');
      if mode = 2 then
      begin
        fnw := paramstr(6);
        if i = 0 then
          val(paramstr(7),xs,i);
        if i = 0 then
          val(paramstr(8),ys,i);
        if i = 0 then
          val(paramstr(9),thr,i);
      end;
    end
    else if mode = 3 then
    begin
      if i = 0 then
        val(paramstr(3),xoff,i);
      if i = 0 then
        val(paramstr(4),yoff,i);
      if i = 0 then
        val(paramstr(5),x0,i);
      if i = 0 then
        val(paramstr(6),y0,i);
      if i = 0 then
        val(paramstr(7),xs,i);
      if i = 0 then
        val(paramstr(8),ys,i);
      if i = 0 then
        val(paramstr(9),zoom,i);
      if i = 0 then
        val(paramstr(10),rot,i);
      if i = 0 then
        val(paramstr(11),thr,i);
      if i = 0 then
        val(paramstr(12),bgc,i);
      if i = 0 then
        val(paramstr(13),fgc,i);
    end
    else if mode <> 0 then
      i := -1;
    if i <> 0 then
    begin
      writeln ('paramstr error');
      exit;
    end;
  end;

  writeln ('bmp:',readbmphdr (fnr,w,h,c,c00));
  writeln ('w:',w,' h:',h,' c:',c,' c00:',c00);
  readln;

  if mode = 0 then
  begin
    writeln ('read + eof');
    for i := 0 to 3 do
    begin
      tm[0][0] := timer;
      assign(fb,fnr);
      reset(fb);
      ww := 0;
      while not eof(fb) do
      begin
        read(fb,b);
        inc(ww);
      end;
      close(fb);
      tm[0][1] := timer;
      writeln ('ww=',ww,' fr=',word(tm[0][1]-tm[0][0])/18.2:7:3);
    end;
    writeln ('read');
    for i := 0 to 3 do
    begin
      tm[0][0] := timer;
      assign(fb,fnr);
      reset(fb);
      for ww := 0 to 38462-1 do
      begin
        {$i-}
        read(fb,b);
        {$i+}
        if ioresult <> 0 then
        begin
          writeln ('error');
          exit;
        end;
      end;
      close(fb);
      tm[0][1] := timer;
      writeln ('ww=',ww,' fr=',word(tm[0][1]-tm[0][0])/18.2:7:3);
    end;
    writeln ('blockread 1');
    for i := 0 to 3 do
    begin
      tm[0][0] := timer;
      assign(f,fnr);
      reset(f,1);
      for ww := 0 to 38400 do
      begin
        {$i-}
        blockread(f,b1024,1,wr);
        {$i+}
        if ioresult <> 0 then
        begin
          writeln ('error');
          exit;
        end;
        if wr < 1 then
          writeln ('ww=',ww,' wr=',wr);
      end;
      close(f);
      tm[0][1] := timer;
      writeln ('ww=',ww,' fr=',word(tm[0][1]-tm[0][0])/18.2:7:3);
    end;
    writeln ('blockread 10');
    for i := 0 to 3 do
    begin
      tm[0][0] := timer;
      assign(f,fnr);
      reset(f,1);
      for ww := 0 to 3840 do
      begin
        {$i-}
        blockread(f,b1024,10,wr);
        {$i+}
        if ioresult <> 0 then
        begin
          writeln ('error');
          exit;
        end;
        if wr < 10 then
          writeln ('ww=',ww,' wr=',wr);
      end;
      close(f);
      tm[0][1] := timer;
      writeln ('ww=',ww,' fr=',word(tm[0][1]-tm[0][0])/18.2:7:3);
    end;
    writeln ('seek 1');
    for i := 0 to 3 do
    begin
      tm[0][0] := timer;
      assign(f,fnr);
      reset(f,1);
      for ww := 0 to 38400 do
      begin
        {$i-}
        seek (f,filepos(f)+1);
        {$i+}
        if ioresult <> 0 then
        begin
          writeln ('error');
          exit;
        end;
      end;
      close(f);
      tm[0][1] := timer;
      writeln ('ww=',ww,' fr=',word(tm[0][1]-tm[0][0])/18.2:7:3);
    end;
    writeln ('seek 10');
    for i := 0 to 3 do
    begin
      tm[0][0] := timer;
      assign(f,fnr);
      reset(f,1);
      for ww := 0 to 3840 do
      begin
        {$i-}
        seek (f,filepos(f)+10);
        {$i+}
        if ioresult <> 0 then
        begin
          writeln ('error');
          exit;
        end;
      end;
      close(f);
      tm[0][1] := timer;
      writeln ('ww=',ww,' fr=',word(tm[0][1]-tm[0][0])/18.2:7:3);
    end;
    readln;
  end;

  if (mode = 1) or (mode = 2) then
  begin
    initgraph (graphdriver,graphmode,'\tp6\bgi');
    if graphresult <> 0 then
    begin
      writeln ('graph error');
      exit;
    end;

    tm[0][0] := timer;
    s := readbmp (fnr,x0,y0,inv);
    tm[0][1] := timer;
    if mode = 2 then
      ss := writebmp(fnw,x0,y0,xs,ys,thr)
    else
      ss := '-';
    tm[0][2] := timer;

    readln;
    closegraph;

    writeln ('read:>',s,'< ',word(tm[0][1]-tm[0][0])/18.2:7:3);
    writeln ('write:>',ss,'< ',word(tm[0][2]-tm[0][1])/18.2:7:3);
    readln;
  end;

  if mode = 3 then
  begin
    writeln ('memavail:',memavail);
    bmpbuf1 := getbmpbuf(xs,ys);
    writeln (ofs(bmpbuf1),' ',seg(bmpbuf1));
    writeln ('memavail:',memavail);
    readln;

    initgraph (graphdriver,graphmode,'\tp6\bgi');
    if graphresult <> 0 then
    begin
      writeln ('graph error');
      exit;
    end;

  {
    for yy := 0 to 479 do
      for xx := 0 to 639 do
        if false then
        begin
          r.ah := $0c;
          r.al := 8;
          r.cx := xx;
          r.dx := yy;
          intr($10,r);
        end
      else
        putpixel(xx,480-yy,8);
  }
    s := '-';
    setwritemode (xorput);
    if fnr = '' then
    begin
      line (x0,y0,x0+xs-1,y0-ys+1);
      line (x0+xs-1,y0,x0+xs-1,y0);
      line (x0,y0-ys+1,x0,y0-ys+1);
      cc := readkey;
      line (x0,y0,x0+xs-1,y0-ys+1);
      line (x0,y0-ys+1,x0+xs-1,y0);
    end
    else
      if (xs = 640) and (ys = 480) then
      begin
        pba := bmpbuf1^.buf;
        for ww := 0 to bmpbuf1^.size-1 do
        pba^[ww] := 0;
        for ww := 0 to 79 do
          pba^[ww] := ww;
        for ww := 0 to 479 do
          pba^[ww*80] := ww;
        s := showbmpbuf(bmpbuf1,x0,y0,xs,ys,bgc,fgc);
        readln;
      end;

      s := '';
      s2 := '';
      for i := 0 to 3 do
      begin
        clearviewport;
        tm[i][0] := timer;
        if s = '' then
          s := readbmpbuf(fnr,xoff,yoff,xs,ys,zoom,thr,(rot+i) mod 4,bmpbuf1);
        tm[i][1] := timer;
        if s = '' then
          s2 := showbmpbuf(bmpbuf1,x0,y0,xs,ys,bgc,fgc);
        tm[i][2] := timer;
        if s2 <> '' then
          s := '[OK]';
        if s = '' then
        begin
          cc := readkey;
          line (x0,y0,x0+xs-1,y0-ys+1);
          line (x0,y0-ys+1,x0+xs-1,y0);
        end;

{
        if s = '' then
          cc := readkey;
        clearviewport;

        if s = '' then
        begin
          cc := readkey;
          line (x0,y0,x0+xs-1,y0-ys+1);
          line (x0,y0-ys+1,x0+xs-1,y0);
        end;
}
        if s = '' then
          cc := readkey;
      end;
    readln;
    closegraph;
    writeln ('read:>',s,'<>',s2,'<');
    for i := 0 to 3 do
    begin
      write ('read=',word(tm[i][1]-tm[i][0])/18.2:7:3);
      writeln (' show=',word(tm[i][2]-tm[i][1])/18.2:7:3);
    end;
    readln;
  end;

end.
